﻿#light


let alma=5
let double x = 2*x
let mutable aktualisCim="Budapest, Egyetem tér 1-3"

printfn "aktualisCim változó tartalma   %A" (aktualisCim)
printfn "Alma változó tartalma   %A" (alma)
printfn "double 5:   %d" (double 5)    
aktualisCim <- "Budapest, Pázmány Péter sétány 1"
printfn "aktualisCim változó új tartalma   %A" (aktualisCim)


let nagyobb (x:int) y:int =
    match x with
    | _ when x<y -> y
    | _ when x>y -> x
    | otherwise -> x

type Tree<'a>=
    | Node of Tree<'a> * Tree<'a> * 'a
    | Leaf
    member x.Depth =
        match x with
        | Leaf -> 0
        | Node(ls,rs,_) -> nagyobb ls.Depth rs.Depth + 1

let fa1=Node(Leaf,Node(Leaf,Leaf,0.0),0.0)
printfn "Fa mélyége: %d" (fa1.Depth)
//Fa mélysége: 2

let rec fib n =
    match n with 
    | 0 -> 1
    | 1 -> 1
    | x -> fib (n-1) + fib (n-2)
    

type OsztalyPelda(dx:int)=
    member x.DX = dx
    member x.Eltol y = OsztalyPelda(dx + y)

type Vector2D(dx: float, dy:float)=
    let len = sqrt (dx * dx + dy * dy)
    member x.DX = dx
    member x.DY = dy
    member x.Length= len
    member x.Scale(k) = Vector2D(k*dx , k* dy)
    static member Zero = Vector2D(0.0,0.0)
    static member OneX = Vector2D(1.0,0.0)

let vec1=Vector2D(3.0,4.0)
printfn "%A" vec1.DX
    
type UnitVector2D(dx,dy) =
    let tolerance = 0.000001
    let len = sqrt (dx * dx + dy * dy)
    do if(abs len - 1.0) >= tolerance then failwith "not a unit vector"
    member x.DX = dx
    member x.DY = dy
    new() = UnitVector2D (1.0, 0.0)

    
type MutableVector2D(dx:float,dy:float) =
    let mutable currDX = dx
    let mutable currDY = dy
    member v.DX with get() = currDX and set(k)= currDX <- k
    member v.DY with get() = currDY and set(k)= currDY <- k

let mutVect= MutableVector2D(2.0,3.0)
printfn "%A" mutVect.DX
mutVect.DX <- 3.0
printfn "Változatás után: %A" mutVect.DX

let i=List.length [1..9]

let sign x =
    match x with
    | _ when x<0 -> -1
    | _ when x>0 -> 1
 
 
let stringType (t : obj) =
  match t with
  | :? System.Boolean -> "Boolean"
  | :? System.Byte -> "Byte"
  | :? System.Int32 -> "Int32"
  | :? System.Double -> "Double" 
  | _ -> "Unknown"
 
printfn "%A" (stringType (box 14uy))
printfn "%A" (stringType (box false))
printfn "%A" (stringType (box "Foo"))


let generateStamp =
   let count = ref 0
   (fun () -> count := !count + 1; !count)
   
let a:int=generateStamp()
let b:int=generateStamp()
   
printfn "%d" (a)
printfn "%d" (b)


let rec listSum (l:list<int>) =
    match l with
    | [] -> 0
    | x::xs -> x + listSum xs

let lista1=[1;2;3;4;5]
printfn "lista1 elmeinek az összege: %d" (listSum lista1)
 

